// Run though and calculate the phase and magnitude for our
// custom designed filters

rfile angle
 
myfilter = function (a0, a1, a2, b0, b1) {
	pi = 3.1415;

	//Perform the basic operation of
	//running through all frequencies
	//and calculating the value of the
	//filter defined by;
	// (a0 + a1z + a2z^2) / (b0 + b1z + z^2)

	//Sampling rate is 10 radians/sec
	for (i in 0:pi:.1) {
		indx = (i/.1)+1;
		z = 1*cos(i) + 1j*sin(i);
		v[indx;] = a0 + a1*z + a2*z^2;
		v[indx;] = v[indx;]/(b0 + b1*z + z^2);
		v[indx;] = v[indx;]*v[indx;];
	}
	return v;
}

dolocalplot = function(window, data, tit) {

	//setterm("post default enh", window);
	//setoutput(tit+".ps", window);

	title(tit, window);
	plot(abs(data),,window)
	title(" ", window);
	plot(angle(data),,window)
	//nomultiplot(window);

	//setterm("beos", window);
	//setoutput(, window);

}

multiplot(8,2,window)
A1 = myfilter(0.2222545, -0.4445091, 0.2222545, 0.04520149, 0.1561833);
dolocalplot(0, A1, "A1");

A2 = myfilter(0.3085386, -0.6170772, 0.3085386, 0.4509715, 0.2168171);
A2 = 0.028164.*A2;
dolocalplot(0, A2, "A2");

B1 = myfilter(5.490566, 9.752955, 5.490566, 0.7226400, 0.4944635);
dolocalplot(0, B1, "B1");
B2 = myfilter(0.5871082, -1.042887, 0.5871082, 0.7226400, -0.4944634);
dolocalplot(0, B2, "B2");

C1 = myfilter(0.1747744, 0.00000001517270, 0.1747744, 0.5741567, 1.224608);
dolocalplot(0, C1, "C1");
C2 = myfilter(1.399382, 0.0000001214846, 1.399382, 0.5741567, -1.224608);
dolocalplot(0, C2, "C2");

D1 = myfilter(9.208915, 15.61801, 9.208915, 0.5087094, -1.291110);
dolocalplot(0, D1, "D1");
D2 = myfilter(2.300089, 1.721670, 2.300089, 0.8092186, -1.069291);
dolocalplot(0, D2, "D2");

//pclose();
//pend();
