// mksquare.r
// This will generate the appropriate order 
// fourier series sum of sines to create a
// square wave.  Good for digital communications

mksquare = function(f, fs, cycles, order) {

	//Order must be odd
	if (!exist(order) || !exist(f) || !exist(fs) || !exist(cycles)) {
		error("\n\tYou must specify all arguments");
	} 
	if (mod(order, 2) != 1) {
		error("\n\tThe order must be negative");
	}

	t = 0:cycles/f:1/fs;
	s = zeros(size(t));
	for (i in 1:order:2) {
		s = s + (1/i)*sin(2*3.14*i*f.*t);
	}
	return(s);
}

